## picolibc 1.4.4

=== meson_options.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2019 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
option('fast-strcmp', type: 'boolean', value: true,
       description: 'Always optimize strcmp for performance')

option('have-alias-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Compiler supports __alias__ attribute')

option('multilib', type: 'boolean', value: true,
       description: 'Enable multilib compile')

option('multilib-list', type: 'array', value: [],
       description: 'List of multilib configurations to build for')

option('native-tests', type: 'boolean', value: false,
       description: 'Run math tests against native libc too')

option('picolib', type: 'boolean', value: true,
       description: 'Include pico lib bits')

option('specsdir', type: 'string',
       description: 'Installation directory for .specs file')

option('sysroot-install', type: 'boolean', value: false,
       description: 'Install in gcc sysroot')

option('tests', type: 'boolean', value: false,
       description: 'Enable tests')

option('newlib-tinystdio', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Use tiny stdio from avr libc')
option('tinystdio', type: 'boolean', value: true,
       description: 'Use tiny stdio from avr libc')

#
# Options applying to both legacy stdio and tinystdio
#
option('io-c99-formats', type: 'boolean', value: true,
       description: 'enable C99 support in IO functions like printf/scanf')
option('newlib-io-c99-formats', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable C99 support in IO functions like printf/scanf')
option('io-long-long', type: 'boolean', value: false,
       description: 'enable long long type support in IO functions like printf/scanf')
option('newlib-io-long-long', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable long long type support in IO functions like printf/scanf')

#
# Options applying only to tinystdio
#
option('io-float-exact', type: 'boolean', value: true,
       description: 'use float/string code which supports round-tripping')
option('posix-io', type: 'boolean', value: true,
       description: 'Provide fopen/fdopen using POSIX I/O (open, close, read, write, lseek)')
option('posix-console', type: 'boolean', value: false,
       description: 'Use POSIX I/O for stdin/stdout/stderr')

#
# Options applying to only legacy stdio
#
option('newlib-elix-level', type: 'integer', value: 0,
       description: 'desired elix library level (0-4)')
option('newlib-fseek-optimization', type: 'boolean', value: false,
       description: 'enable fseek optimization')
option('newlib-fvwrite-in-streamio', type: 'boolean', value: false,
       description: 'disable iov in streamio')
option('newlib-global-stdio-streams', type: 'boolean', value: false,
       description: 'enable global stdio streams')
option('newlib-io-float', type: 'boolean', value: false,
       description: 'enable printf/scanf family float support')
option('newlib-io-pos-args', type: 'boolean', value: false,
       description: 'enable printf-family positional arg support')
option('newlib-io-long-double', type: 'boolean', value: false,
       description: 'enable long double type support in IO functions printf/scanf (newlib stdio only)')
option('newlib-nano-formatted-io', type: 'boolean', value: false,
       description: 'Use nano version formatted IO')
option('newlib-reent-small', type: 'boolean', value: false,
       description: 'enable small reentrant struct support')
option('newlib-stdio64', type: 'boolean', value: true,
       description: 'Include stdio64 with newlib stdio')
option('newlib-unbuf-stream-opt', type: 'boolean', value: false,
       description: 'enable unbuffered stream optimization in streamio')
option('newlib-wide-orient', type: 'boolean', value: false,
       description: 'Turn off wide orientation in streamio')

#
# Internationalization options
#

option('newlib-iconv', type: 'boolean', value: false,
       description: 'enable iconv library support')
option('newlib-iconv-encodings', type: 'boolean', value: false,
       description: 'enable specific comma-separated list of bidirectional iconv encodings to be built-in')
option('newlib-iconv-from-encodings', type: 'boolean', value: false,
       description: 'enable specific comma-separated list of "from" iconv encodings to be built-in')
option('newlib-iconv-to-encodings', type: 'boolean', value: false,
       description: 'enable specific comma-separated list of "to" iconv encodings to be built-in')
option('newlib-iconv-external-ccs', type: 'boolean', value: false,
       description: 'enable capabilities to load external CCS files for iconv')
option('newlib-locale-info', type: 'boolean', value: false,
       description: 'locale support')
option('newlib-locale-info-extended', type: 'boolean', value: false,
       description: 'extended locale support')
option('newlib-mb', type: 'boolean', value: false,
       description: 'enable multibyte support')

#
# Startup/shutdown options
#
option('lite-exit', type: 'boolean', value: true,
       description: 'enable light weight exit')
option('newlib-atexit-dynamic-alloc', type: 'boolean', value: false,
       description: 'enable dynamic allocation of atexit entries')
option('newlib-global-atexit', type: 'boolean', value: false,
       description: 'enable atexit data structure as global')
option('newlib-initfini', type: 'boolean', value: true,
       description: 'Supports _init() and _fini()')
option('newlib-initfini-array', type: 'boolean', value: true,
       description: 'compiler supports INIT_ARRAY section types')
option('newlib-register-fini', type: 'boolean', value: false,
       description: 'enable finalization function registration using atexit')

#
# Malloc option
#
option('newlib-nano-malloc', type: 'boolean', value: true,
       description: 'use small-footprint nano-malloc implementation')

#
# Locking support
#
option('newlib-multithread', type: 'boolean', value: false,
       description: 'enable support for multiple threads')
option('newlib-retargetable-locking', type: 'boolean', value: false,
       description: 'Allow locking routines to be retargeted at link time')

#
# Thread-local storage support
#
option('thread-local-storage', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'use thread local storage for static data (default: automatically detect support)')
option('tls-model', type: 'string', value: 'local-exec',
       description: 'tls model (global-dynamic, local-dynamic, initial-exec or local-exec)')
option('newlib-global-errno', type: 'boolean', value: false,
       description: 'use global errno variable')

#
# Use "obsolete" math code, which use 'float' for 'float' functions
# instead of the newer code which uses 'double' instead.
#
option('newlib-obsolete-math', type: 'combo', choices: ['true', 'false', 'auto'],
       value: 'auto',
       description: 'Use float type for float valued math routines (default: automatic based on platform)')

#
# Obsolete newlib options
#
option('newlib-long-time_t', type: 'boolean', value: false,
       description: 'define time_t to long instead of a 64-bit type')
option('newlib-missing-syscall-names', type: 'boolean', value: false,
       description: 'system only provides regular syscall API')
option('newlib-reentrant-syscalls-provided', type: 'boolean', value: false,
       description: 'system provides reentrant syscall API')
option('newlib-supplied-syscalls', type: 'boolean', value: false,
       description: 'newlib supplies system call functions')

=== hello-world/Makefile ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2019 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

CFLAGS=--specs=picolibc.specs --oslib=semihost

CC_RISCV=riscv64-unknown-elf-gcc
CFLAGS_RISCV=$(CFLAGS) -march=rv32imac -mabi=ilp32 -Thello-world-riscv.ld

CC_ARM=arm-none-eabi-gcc
CFLAGS_ARM=$(CFLAGS) -mcpu=cortex-m3 -Thello-world-arm.ld

all: hello-world-riscv.elf hello-world-arm.elf

hello-world-riscv.elf: hello-world.c
	$(CC_RISCV) $(CFLAGS_RISCV) -o $@ $^

hello-world-arm.elf: hello-world.c
	$(CC_ARM) $(CFLAGS_ARM) -o $@ $^

clean:
	rm -f *.elf *.map

=== debian/changelog ===
picolibc (1.4.4-1) unstable; urgency=medium

  * New upstream 1.4.4

  * Fix printf 'g' output when using 'ryu' conversion code

  * Add fenv for ARM from newlib

 -- Keith Packard <keithp@keithp.com>  Wed, 10 Jun 2020 16:06:11 -0700

picolibc (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3

  * Make fix for CVE 2019-14871 - CVE 2019-14878 in original newlib
    stdio code not call 'abort'. Allocation failures are now reported
    back to the application.

  * Add 'exact' floating point print/scan code to tinystdio. Thanks
    to Sreepathi Pai for pointing me at the Ryu code by Ulf
    Adams.

  * Add regular expression functions from newlib. These were removed
    by accident while removing POSIX filesystem-specific code.

  * Make tinystdio versions of [efg]cvt functions. This means that the
    default tinystdio version of picolibc no longer calls malloc from
    these functions.

  * More clang-compatibility fixes. (Thanks to Denis Feklushkin)

  * Remove stdatomic.h and tgmath.h. (they should not be provide by picolibc)

 -- Keith Packard <keithp@keithp.com>  Tue, 09 Jun 2020 12:45:58 -0700

picolibc (1.4.2-3) unstable; urgency=medium

  * Move lx106 bits back to original location

 -- Keith Packard <keithp@keithp.com>  Wed, 03 Jun 2020 12:05:15 -0700

picolibc (1.4.2-2) unstable; urgency=medium

  * Remove aarch64 support to avoid hitting NEW queue

 -- Keith Packard <keithp@keithp.com>  Thu, 21 May 2020 11:20:07 -0700

picolibc (1.4.2-1) unstable; urgency=medium

  * Clang source compatibility. Clang should now be able to compile
    the library.

  * Testing on github on push and pull-request. For now, this is
    limited to building the library due to a bug in qemu.

  * Get newlib stdio working again. You can now usefully use newlib's
    stdio. This requires a working malloc and is substantially larger
    than tinystdio, but has more accurate floating point input. This
    requires POSIX functions including read, write and a few others.

  * Fix long double strtold. The working version is only available
    when using tinystdio; if using newlib stdio, strtold is simply not
    available.

  * Improve tinystdio support for C99 printf/scanf additions.

  * Check for correct prefix when sysroot-install option is
    selected. The value of this option depends on how gcc was
    configured, and (alas) meson won't let us set it at runtime, so
    instead we complain if the wrong value was given and display the
    correct value.

  * Sync up with current newlib master

  * Add aarch64-linux-gnu support

 -- Keith Packard <keithp@keithp.com>  Thu, 21 May 2020 08:51:37 -0700

picolibc (1.4.1-2) unstable; urgency=medium

  * Build with newer GCC versions

 -- Keith Packard <keithp@keithp.com>  Sat, 18 Apr 2020 14:56:40 -0700

picolibc (1.4.1-1) unstable; urgency=medium

  * ARM TLS corruption fix
  * Compilation compatibility fixes
  * Add -msave-restore to RISC-V version

 -- Keith Packard <keithp@keithp.com>  Mon, 09 Mar 2020 12:02:54 -0700

picolibc (1.4-1) unstable; urgency=medium

  * Merge upstream license changes from BSD 4-clause to BSD 3-clause
  * Add copyright information where missing
  * Create debian/copyright file automatically by perusing source files

 -- Keith Packard <keithp@keithp.com>  Tue, 04 Feb 2020 23:07:07 -0800

picolibc (1.3-1) unstable; urgency=medium

  * New upstream release (1.3)
  * Add testing
  * Add lx106 binary package for xtensa-lx106-elf
  * Fix some RISC-V ABI issues

 -- Keith Packard <keithp@keithp.com>  Tue, 31 Dec 2019 23:44:40 -0800

picolibc (1.2.1-1) unstable; urgency=medium

  * New upstream release (1.2.1)
  * Switch back to __OBSOLETE_MATH for machines without hw double
  * Include realloc and mallinfo in the library
  * Use SYS_EXIT on semihost implementations without SYS_EXIT_EXTENDED

 -- Keith Packard <keithp@keithp.com>  Mon, 02 Dec 2019 20:55:24 -0800

picolibc (1.2-1) unstable; urgency=medium

  * New upstream release  (1.2)
  * Add fopen/fdopen and clock semihost support
  * Fix picolibc.ld to actually use user-defined memory areas

 -- Keith Packard <keithp@keithp.com>  Thu, 28 Nov 2019 10:46:30 -0800

picolibc (1.1.1-1) unstable; urgency=medium

  * New upstream release (1.1.1)
  * Compute TLS support in GCC automatically which disables this on ARM
  * Change how picolibc.specs gets installed
  * Update cross-compile meson files to match upstream

 -- Keith Packard <keithp@keithp.com>  Wed, 20 Nov 2019 00:15:51 -0800

picolibc (1.1-2) unstable; urgency=medium

  * Make install depend on compilers so .specs files work afterwards

 -- Keith Packard <keithp@keithp.com>  Fri, 15 Nov 2019 17:00:46 -0800

picolibc (1.1-1) unstable; urgency=medium

  * Upstream release 1.1
  * semihost support
  * Posix I/O support on Posix systems
  * Merged newlib code
  * Hello world example

 -- Keith Packard <keithp@keithp.com>  Thu, 14 Nov 2019 17:01:13 -0800

picolibc (1.0-1) unstable; urgency=medium

  * Version 1.0
  * Rename from newlib-nano
  * Switch to TLS
  * Add picolib to provide tls helper and sbrk implementation
  * Provide linker script sample
  * Adjust debhelper dependency to >= 12
  * Add riscv target
  * Incorporate printf fixes from NuttX

 -- Keith Packard <keithp@keithp.com>  Sun, 22 Sep 2019 19:21:20 -0700

=== debian/control ===
Source: picolibc
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper-compat (= 13), gcc-arm-none-eabi, gcc-riscv64-unknown-elf, gcc-xtensa-lx106,
 meson, ninja-build, qemu-system-arm
Standards-Version: 4.5.0
Rules-Requires-Root: no
Section: devel
HomePage: https://keithp.com/picolibc
Vcs-Git: git://keithp.com/git/picolibc.git
Vcs-Browser: https://keithp.com/cgit/picolibc.git/

Package: picolibc-riscv64-unknown-elf
Architecture: all
Depends: ${misc:Depends}, gcc-riscv64-unknown-elf
Description: Smaller embedded C library for RISC-V development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 RISC-V processors.

Package: picolibc-arm-none-eabi
Architecture: all
Depends: ${misc:Depends}, gcc-arm-none-eabi
Description: Smaller embedded C library for ARM development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ARM processors. This library is intended to replace libnewlib-nano

Package: picolibc-xtensa-lx106-elf
Architecture: all
Depends: ${misc:Depends}, gcc-xtensa-lx106
Description: Smaller embedded C library for ESP8266 development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ESP8266 processors.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# Don't let dpkg-buildflags mess with the compiler settings
export DEB_CPPFLAGS_MAINT_SET =
export DEB_CFLAGS_MAINT_SET =
export DEB_LDFLAGS_MAINT_SET =

BUILDDIR=build

BUILDPATH=$(shell pwd)/debian/$(BUILDDIR)

%:
	dh $@ -B$(BUILDDIR)

RISCV_ARCH=riscv64-unknown-elf
ARM_ARCH=arm-none-eabi
LX106_ARCH=xtensa-lx106-elf

MESON_SHARED_FLAGS = \
	-Dc_args='-Wdate-time -ffile-prefix-map=$(BUILDPATH)=. -fdebug-prefix-map=$(BUILDPATH)=.' \
	--prefix=/usr

MESON_RISCV_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	--cross-file cross-$(RISCV_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(RISCV_ARCH) \
	-Dincludedir=lib/picolibc/$(RISCV_ARCH)/include \
	-Dlibdir=lib/picolibc/$(RISCV_ARCH)/lib

MESON_ARM_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dtests=true \
	--cross-file cross-$(ARM_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(ARM_ARCH) \
	-Dincludedir=lib/picolibc/$(ARM_ARCH)/include \
	-Dlibdir=lib/picolibc/$(ARM_ARCH)/lib

MESON_LX106_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	--cross-file cross-$(LX106_ARCH).txt \
	-Dnewlib-long-time_t=true \
	-Dspecsdir=/usr/lib/$(LX106_ARCH) \
	-Dincludedir=lib/$(LX106_ARCH)/include \
	-Dlibdir=lib/$(LX106_ARCH)/lib

override_dh_autoreconf:
	echo 'no reconf needed'

override_dh_auto_clean:
	rm -fr debian/$(BUILDDIR)

override_dh_auto_configure:
	meson . debian/$(BUILDDIR)/$(RISCV_ARCH) $(MESON_RISCV_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(ARM_ARCH) $(MESON_ARM_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(LX106_ARCH) $(MESON_LX106_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'

override_dh_auto_build:
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(LX106_ARCH) && ninja -v

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && meson test --timeout-multiplier=10
endif

override_dh_auto_install:
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(LX106_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install

=== debian/tests/control ===
Test-Command: riscv64-unknown-elf-gcc --specs=picolibc.specs -o /tmp/risc-v debian/tests/touch.c -lm
Depends: @, gcc-riscv64-unknown-elf

Test-Command: arm-none-eabi-gcc --specs=picolibc.specs -o /tmp/touch-arm debian/tests/touch.c -lm
Depends: @, gcc-arm-none-eabi

## picolibc 1.5.1

=== meson_options.txt ===
--- 
+++ 
@@ -38,26 +38,38 @@
 option('have-alias-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
        description: 'Compiler supports __alias__ attribute')
 
+option('have-format-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
+       description: 'Compiler supports __format__ attribute')
+
 option('multilib', type: 'boolean', value: true,
        description: 'Enable multilib compile')
 
 option('multilib-list', type: 'array', value: [],
        description: 'List of multilib configurations to build for')
 
+option('picolib', type: 'boolean', value: true,
+       description: 'Include pico lib bits')
+
+option('picocrt', type: 'boolean', value: true,
+       description: 'Include pico crt bits')
+
+option('specsdir', type: 'string',
+       description: 'Installation directory for .specs file')
+
+option('sysroot-install', type: 'boolean', value: false,
+       description: 'Install in gcc sysroot')
+
+#
+# Testing options
+#
 option('native-tests', type: 'boolean', value: false,
        description: 'Run math tests against native libc too')
-
-option('picolib', type: 'boolean', value: true,
-       description: 'Include pico lib bits')
-
-option('specsdir', type: 'string',
-       description: 'Installation directory for .specs file')
-
-option('sysroot-install', type: 'boolean', value: false,
-       description: 'Install in gcc sysroot')
-
 option('tests', type: 'boolean', value: false,
        description: 'Enable tests')
+option('tests-enable-stack-protector', type: 'boolean', value: true,
+       description: 'tests enable stack protector')
+option('tests-disable-full-malloc-stress', type: 'boolean', value: true,
+       description: 'tests disable stress test for full malloc')
 
 option('newlib-tinystdio', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
        description: 'Use tiny stdio from avr libc')
@@ -81,6 +93,8 @@
 #
 option('io-float-exact', type: 'boolean', value: true,
        description: 'use float/string code which supports round-tripping')
+option('atomic-ungetc', type: 'boolean', value: true,
+       description: 'use atomics in fgetc/ungetc to make them re-entrant')
 option('posix-io', type: 'boolean', value: true,
        description: 'Provide fopen/fdopen using POSIX I/O (open, close, read, write, lseek)')
 option('posix-console', type: 'boolean', value: false,
@@ -89,7 +103,7 @@
 #
 # Options applying to only legacy stdio
 #
-option('newlib-elix-level', type: 'integer', value: 0,
+option('newlib-elix-level', type: 'integer', value: 2,
        description: 'desired elix library level (0-4)')
 option('newlib-fseek-optimization', type: 'boolean', value: false,
        description: 'enable fseek optimization')
@@ -118,16 +132,19 @@
 # Internationalization options
 #
 
-option('newlib-iconv', type: 'boolean', value: false,
-       description: 'enable iconv library support')
-option('newlib-iconv-encodings', type: 'boolean', value: false,
+option('newlib-iconv-encodings', type: 'array',
        description: 'enable specific comma-separated list of bidirectional iconv encodings to be built-in')
-option('newlib-iconv-from-encodings', type: 'boolean', value: false,
+option('newlib-iconv-from-encodings', type: 'array',
        description: 'enable specific comma-separated list of "from" iconv encodings to be built-in')
-option('newlib-iconv-to-encodings', type: 'boolean', value: false,
+option('newlib-iconv-to-encodings', type: 'array',
        description: 'enable specific comma-separated list of "to" iconv encodings to be built-in')
-option('newlib-iconv-external-ccs', type: 'boolean', value: false,
-       description: 'enable capabilities to load external CCS files for iconv')
+option('newlib-iconv-external-ccs', type: 'boolean', value:false,
+       description: 'Load iconv CCS tables from files rather than having them built-in')
+option('newlib-iconv-dir', type: 'string',
+       description: 'Installation directory for iconv CCS files')
+option('newlib-iconv-runtime-dir', type: 'string',
+       description: 'Path used at runtime to locate iconv CCS files')
+
 option('newlib-locale-info', type: 'boolean', value: false,
        description: 'locale support')
 option('newlib-locale-info-extended', type: 'boolean', value: false,
@@ -160,9 +177,9 @@
 #
 # Locking support
 #
-option('newlib-multithread', type: 'boolean', value: false,
+option('newlib-multithread', type: 'boolean', value: true,
        description: 'enable support for multiple threads')
-option('newlib-retargetable-locking', type: 'boolean', value: false,
+option('newlib-retargetable-locking', type: 'boolean', value: true,
        description: 'Allow locking routines to be retargeted at link time')
 
 #
@@ -175,6 +192,8 @@
 option('newlib-global-errno', type: 'boolean', value: false,
        description: 'use global errno variable')
 
+# 
+# Math options
 #
 # Use "obsolete" math code, which use 'float' for 'float' functions
 # instead of the newer code which uses 'double' instead.
@@ -182,6 +201,14 @@
 option('newlib-obsolete-math', type: 'combo', choices: ['true', 'false', 'auto'],
        value: 'auto',
        description: 'Use float type for float valued math routines (default: automatic based on platform)')
+option('newlib-obsolete-math-float', type: 'combo', choices: ['true', 'false', 'auto'],
+       value: 'auto',
+       description: 'Use old math code that uses float type for float valued math routines (default: automatic based on platform)')
+option('newlib-obsolete-math-double', type: 'combo', choices: ['true', 'false', 'auto'],
+       value: 'auto',
+       description: 'Use old math code for double valued math routines (default: automatic based on platform)')
+option('want-math-errno', type: 'boolean', value: false,
+       description: 'Set errno in math functions according to stdc (default: false)')
 
 #
 # Obsolete newlib options
@@ -194,4 +221,3 @@
        description: 'system provides reentrant syscall API')
 option('newlib-supplied-syscalls', type: 'boolean', value: false,
        description: 'newlib supplies system call functions')
-

=== hello-world/Makefile ===
--- 
+++ 
@@ -33,21 +33,44 @@
 # OF THE POSSIBILITY OF SUCH DAMAGE.
 #
 
-CFLAGS=--specs=picolibc.specs --oslib=semihost
+CFLAGS=--oslib=semihost -O -g -Wl,-gc-sections
 
-CC_RISCV=riscv64-unknown-elf-gcc
-CFLAGS_RISCV=$(CFLAGS) -march=rv32imac -mabi=ilp32 -Thello-world-riscv.ld
+CPP_RISCV=riscv64-unknown-elf-g++ -specs=picolibcpp.specs 
+CC_RISCV=riscv64-unknown-elf-gcc -specs=picolibc.specs 
+CFLAGS_RISCV=$(CFLAGS) -march=rv32imac -mabi=ilp32 -Wl,-Thello-world-riscv.ld
 
-CC_ARM=arm-none-eabi-gcc
-CFLAGS_ARM=$(CFLAGS) -mcpu=cortex-m3 -Thello-world-arm.ld
+CPP_ARM=arm-picolibc-eabi-c++ -specs=picolibcpp.specs 
+CC_ARM=arm-picolibc-eabi-gcc -specs=picolibc.specs 
+CFLAGS_ARM=$(CFLAGS) -mcpu=cortex-m3 -Wl,-Thello-world-arm.ld
 
-all: hello-world-riscv.elf hello-world-arm.elf
+CPP_AARCH64=aarch64-unknown-elf-g++ -specs=picolibcpp.specs 
+CC_AARCH64=aarch64-unknown-elf-gcc -specs=picolibc.specs 
+CFLAGS_AARCH64=$(CFLAGS) -Wl,-Thello-world-aarch64.ld
+
+all: hello-world-riscv.elf hello-world-arm.elf hello-world-aarch64.elf \
+	hello-world++-riscv.elf hello-world++-arm.elf hello-world++-aarch64.elf
+
 
 hello-world-riscv.elf: hello-world.c
-	$(CC_RISCV) $(CFLAGS_RISCV) -o $@ $^
+	$(CC_RISCV) $(CFLAGS_RISCV) -o $@ $^ -Wl,-Map=hello-world-riscv.map
 
 hello-world-arm.elf: hello-world.c
-	$(CC_ARM) $(CFLAGS_ARM) -o $@ $^
+	$(CC_ARM) $(CFLAGS_ARM) -o $@ $^ -Wl,-Map=hello-world-arm.map
+
+hello-world-aarch64.elf: hello-world.c
+	$(CC_AARCH64) $(CFLAGS_AARCH64) -o $@ $^ -Wl,-Map=hello-world-aarch64.map
 
 clean:
 	rm -f *.elf *.map
+
+hello-world++-native.elf: hello-world++.c++
+	c++ -o $@ $^
+
+hello-world++-arm.elf:  hello-world++.c++
+	$(CPP_ARM) $(CFLAGS_ARM) -Wl,-Map=hello-world++-arm.map -o $@ $^
+
+hello-world++-riscv.elf:  hello-world++.c++
+	$(CPP_RISCV) $(CFLAGS_RISCV) -Wl,-Map=hello-world++-riscv.map -o $@ $^
+
+hello-world++-aarch64.elf:  hello-world++.c++
+	$(CPP_AARCH64) $(CFLAGS_AARCH64) -Wl,-Map=hello-world++-aarch64.map -o $@ $^

=== debian/changelog ===
picolibc (1.5.1-2) unstable; urgency=medium

  * Mark tests with 'Restrictions: skip-not-installable' to skip
    autopkg test on armhf. Closes: #980086.

 -- Keith Packard <keithp@keithp.com>  Tue, 26 Jan 2021 17:36:43 -0800

picolibc (1.5.1-1) unstable; urgency=medium

  * New upstream release

  * Fix riscv autopkgtest failure

 -- Keith Packard <keithp@keithp.com>  Thu, 14 Jan 2021 10:17:21 -0800

picolibc (1.5-1) unstable; urgency=medium

  * New upstream release

  * Make picolibc more compatible with C++ compilers.

  * Add GCC specs file and linker script for building C++ applications
    with G++ that enable exception handling by linking in call stack
    information.

  * A few clang build fixes, including libm exception generation

  * Nano malloc fixes, especially for 'unusual' arguments

  * Merge in newlib 4.1.0 code

  * More libm exception/errno/infinity fixes, mostly in the gamma funcs.

  * Add tests for all semihost v2.0 functions.

  * A few RISC-V assembly fixes and new libm code.

  * Build fixes to reliably replace generic code with
    architecture-specific implementations.

 -- Keith Packard <keithp@keithp.com>  Thu, 07 Jan 2021 13:06:25 -0800

picolibc (1.4.7-2) unstable; urgency=medium

  * Source upload. Closes: #978412.

 -- Keith Packard <keithp@keithp.com>  Sun, 27 Dec 2020 12:42:53 -0800

picolibc (1.4.7-1) unstable; urgency=medium

  * New upstream version

  * Fix numerous libm exception and errno bugs. The math functions are
    all now verified to match the C19 and Posix standards in this
    area.

  * Change behavior of 'gamma' function to match glibc which returns
    lgamma for this function. Applications should not use this
    function, they should pick either lgamma or tgamma as appropriate.

  * Fix fma/fmaf on arm and RISC-V so that the machine-specific
    versions are used when the hardware has support. Also fix the math
    library to only use fma/fmaf when it is supported by the hardware.

  * Fix numerous nano-malloc bugs, especially with unusual parameters.

  * Change nano-malloc to always clear returned memory.

  * Improve nano-realloc to perform better in various ways, including
    merging adjacent free blocks and expanding the heap.

  * Add malloc tests, both a basic functional test and a stress test.

  * Improve build portability to Windows. Picolibc should now build
    using mingw.

  * Use hardware TLS register on ARM when available.

  * Support clang compiler. Thanks to Denis Feklushkin
    <denis.feklushkin@gmail.com> and Joakim Nohlgård
    <joakim@nohlgard.se>.

  * Avoid implicit float/double conversions. Check this by having
    clang builds use -Wdouble-promotion -Werror=double-promotion flags

  * Have portable code check for machine-specific overrides by
    matching filenames. This avoids building libraries with duplicate
    symbols and retains compatibility with newlib (which uses a
    different mechanism for this effect).

  * Patches to support building with CompCert
    (http://compcert.inria.fr/), a formally verified compiler. Thanks
    to Sebastian Meyer <meyer@absint.com>.

 -- Keith Packard <keithp@keithp.com>  Sun, 25 Oct 2020 15:20:43 -0700

picolibc (1.4.6-2) unstable; urgency=medium

  * Add aarch64-linux-gnu target

 -- Keith Packard <keithp@keithp.com>  Mon, 03 Aug 2020 14:03:51 -0700

picolibc (1.4.6-1) unstable; urgency=medium

  * New upstream version

  * Install 'ssp' (stack smashing protection) header files. This fixes
    compiling with -D_FORTIFY_SOURCE.

  * Make getc/ungetc re-entrant. This feature, which is enabled by
    default, uses atomic instruction sequences that do not require
    OS support.

  * Numerous iconv fixes, including enabling testing and switching
    external CCS file loading to use stdio. By default, iconv provides
    built-in CCS data for all of the supported encodings, which takes
    a fairly large amount of read-only memory. Iconv is now always
    included in picolibc as  it isn't included in applications unless
    explicitly referenced by them.

  * Add __getauxval stub implementation to make picolibc work with
    GCC version 10 compiled for aarch64-linux-gnu.

  * Change how integer- and float- only versions of printf and scanf
    are selected. Instead of re-defining the symbols using the C
    preprocessor, picolibc now re-defines the symbols at link
    time. This avoids having applications compiled with a mixture of
    modes link in multiple versions of the underlying functions, while
    still preserving the smallest possible integer-only
    implementation.

  * Document how to use picolibc on a native POSIX system for
    testing. Check out the [os.md](doc/os.md) file for details.

  * Merge current newlib bits in. This includes better fenv support,
    for which tests are now included in the picolibc test suite.

 -- Keith Packard <keithp@keithp.com>  Mon, 03 Aug 2020 11:47:08 -0700

picolibc (1.4.5-1) unstable; urgency=medium

  * Fix section order in picolibc.ld to give applications correct
    control over the layout of .preserve, .init and .fini regions.

  * Add startup and TLS support for aarch64 and non Cortex-M 32-bit
    arm.

 -- Keith Packard <keithp@keithp.com>  Sun, 28 Jun 2020 15:34:19 -0700

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Priority: optional
 Maintainer: Keith Packard <keithp@keithp.com>
 Build-Depends: debhelper-compat (= 13), gcc-arm-none-eabi, gcc-riscv64-unknown-elf, gcc-xtensa-lx106,
- meson, ninja-build, qemu-system-arm
-Standards-Version: 4.5.0
+ gcc-aarch64-linux-gnu, meson, ninja-build, qemu-system-arm
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Section: devel
-HomePage: https://keithp.com/picolibc
+Homepage: https://keithp.com/picolibc
 Vcs-Git: git://keithp.com/git/picolibc.git
 Vcs-Browser: https://keithp.com/cgit/picolibc.git/
 
@@ -33,3 +33,11 @@
  PicoLibc is a combination of Newlib and AVR libc bits designed
  for small-RAM embedded systems. This package has binaries for
  ESP8266 processors.
+
+Package: picolibc-aarch64-linux-gnu
+Architecture: all
+Depends: ${misc:Depends}, gcc-aarch64-linux-gnu
+Description: Smaller embedded C library for 64-bit ARM development
+ PicoLibc is a combination of Newlib and AVR libc bits designed
+ for small-RAM embedded systems. This package has binaries for
+ ARM 64-bit processors.

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,7 @@
 RISCV_ARCH=riscv64-unknown-elf
 ARM_ARCH=arm-none-eabi
 LX106_ARCH=xtensa-lx106-elf
+AARCH64_ARCH=aarch64-linux-gnu
 
 MESON_SHARED_FLAGS = \
 	-Dc_args='-Wdate-time -ffile-prefix-map=$(BUILDPATH)=. -fdebug-prefix-map=$(BUILDPATH)=.' \
@@ -25,7 +26,7 @@
 
 MESON_RISCV_FLAGS = \
 	$(MESON_SHARED_FLAGS) \
-	--cross-file cross-$(RISCV_ARCH).txt \
+	--cross-file scripts/cross-$(RISCV_ARCH).txt \
 	-Dspecsdir=/usr/lib/picolibc/$(RISCV_ARCH) \
 	-Dincludedir=lib/picolibc/$(RISCV_ARCH)/include \
 	-Dlibdir=lib/picolibc/$(RISCV_ARCH)/lib
@@ -33,18 +34,26 @@
 MESON_ARM_FLAGS = \
 	$(MESON_SHARED_FLAGS) \
 	-Dtests=true \
-	--cross-file cross-$(ARM_ARCH).txt \
+	--cross-file scripts/cross-$(ARM_ARCH).txt \
 	-Dspecsdir=/usr/lib/picolibc/$(ARM_ARCH) \
 	-Dincludedir=lib/picolibc/$(ARM_ARCH)/include \
 	-Dlibdir=lib/picolibc/$(ARM_ARCH)/lib
 
 MESON_LX106_FLAGS = \
 	$(MESON_SHARED_FLAGS) \
-	--cross-file cross-$(LX106_ARCH).txt \
+	--cross-file scripts/cross-$(LX106_ARCH).txt \
 	-Dnewlib-long-time_t=true \
 	-Dspecsdir=/usr/lib/$(LX106_ARCH) \
 	-Dincludedir=lib/$(LX106_ARCH)/include \
 	-Dlibdir=lib/$(LX106_ARCH)/lib
+
+MESON_AARCH64_FLAGS = \
+	$(MESON_SHARED_FLAGS) \
+	-Dtests=true \
+	--cross-file scripts/cross-$(AARCH64_ARCH).txt \
+	-Dspecsdir=/usr/lib/picolibc/$(AARCH64_ARCH) \
+	-Dincludedir=lib/picolibc/$(AARCH64_ARCH)/include \
+	-Dlibdir=lib/picolibc/$(AARCH64_ARCH)/lib
 
 override_dh_autoreconf:
 	echo 'no reconf needed'
@@ -56,18 +65,22 @@
 	meson . debian/$(BUILDDIR)/$(RISCV_ARCH) $(MESON_RISCV_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
 	meson . debian/$(BUILDDIR)/$(ARM_ARCH) $(MESON_ARM_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
 	meson . debian/$(BUILDDIR)/$(LX106_ARCH) $(MESON_LX106_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
+	meson . debian/$(BUILDDIR)/$(AARCH64_ARCH) $(MESON_AARCH64_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
 
 override_dh_auto_build:
 	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && ninja -v
 	cd debian/$(BUILDDIR)/$(ARM_ARCH) && ninja -v
 	cd debian/$(BUILDDIR)/$(LX106_ARCH) && ninja -v
+	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && ninja -v
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	cd debian/$(BUILDDIR)/$(ARM_ARCH) && meson test --timeout-multiplier=10
+	cd debian/$(BUILDDIR)/$(ARM_ARCH) && meson test --timeout-multiplier=10 --verbose
+	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && meson test --timeout-multiplier=10 --verbose
 endif
 
 override_dh_auto_install:
 	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
 	cd debian/$(BUILDDIR)/$(ARM_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
 	cd debian/$(BUILDDIR)/$(LX106_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
+	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install

=== debian/tests/control ===
Test-Command: riscv64-unknown-elf-gcc --specs=picolibc.specs -o /tmp/risc-v debian/tests/touch.c -lm
Depends: @, gcc-riscv64-unknown-elf
Restrictions: skip-not-installable

Test-Command: arm-none-eabi-gcc --specs=picolibc.specs -o /tmp/touch-arm debian/tests/touch.c -lm
Depends: @, gcc-arm-none-eabi
Restrictions: skip-not-installable

## picolibc 1.7.3

=== meson_options.txt ===
--- 
+++ 
@@ -53,11 +53,17 @@
 option('picocrt', type: 'boolean', value: true,
        description: 'Include pico crt bits')
 
+option('semihost', type: 'boolean', value: true,
+       description: 'Include semihost bits')
+
 option('specsdir', type: 'string',
        description: 'Installation directory for .specs file')
 
 option('sysroot-install', type: 'boolean', value: false,
        description: 'Install in gcc sysroot')
+
+option('picoexit', type: 'boolean', value: true,
+       description: 'Smaller exit/atexit/onexit code')
 
 #
 # Testing options
@@ -68,8 +74,10 @@
        description: 'Enable tests')
 option('tests-enable-stack-protector', type: 'boolean', value: true,
        description: 'tests enable stack protector')
-option('tests-disable-full-malloc-stress', type: 'boolean', value: true,
-       description: 'tests disable stress test for full malloc')
+option('tests-enable-full-malloc-stress', type: 'boolean', value: false,
+       description: 'tests enable stress test for full malloc')
+option('tests-enable-posix-io', type: 'boolean', value: true,
+       description: 'tests enable posix-io when available')
 
 option('newlib-tinystdio', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
        description: 'Use tiny stdio from avr libc')
@@ -99,6 +107,8 @@
        description: 'Provide fopen/fdopen using POSIX I/O (open, close, read, write, lseek)')
 option('posix-console', type: 'boolean', value: false,
        description: 'Use POSIX I/O for stdin/stdout/stderr')
+option('format-default', type: 'combo', choices: ['double', 'float', 'integer'], value: 'double',
+       description: 'which printf/scanf versions should be the default')
 
 #
 # Options applying to only legacy stdio
@@ -127,6 +137,8 @@
        description: 'enable unbuffered stream optimization in streamio')
 option('newlib-wide-orient', type: 'boolean', value: false,
        description: 'Turn off wide orientation in streamio')
+option('newlib-have-fcntl', type: 'boolean', value: false,
+       description: 'System has fcntl function')
 
 #
 # Internationalization options

=== debian/changelog ===
picolibc (1.7.3-2) unstable; urgency=medium

  * Add -fno-stack-protector to touch test build. Closes: #995473.

  * Update standards to 4.6.0.1

 -- Keith Packard <keithp@keithp.com>  Mon, 04 Oct 2021 22:02:31 -0700

picolibc (1.7.3-1) unstable; urgency=medium

  * New upstream release

  * Add -Wall -Wextra to default builds. Fixed warnings this raised.

  * Add htonl and friends (based on __htonl). Thanks to Johan de
    Claville Christiansen

  * Set errno in scalbn and scalbnf (patch forwarded to newlib).

  * Merge newlib recent changes which includes a couple of libm fixes.

 -- Keith Packard <keithp@keithp.com>  Thu, 30 Sep 2021 13:21:44 -0700

picolibc (1.7.2-2) unstable; urgency=medium

  * Build with updated gcc version

 -- Keith Packard <keithp@keithp.com>  Wed, 21 Jul 2021 14:08:52 -0700

picolibc (1.7.2-1) unstable; urgency=medium

  * Fix picolibc.ld to split C++ exceptions back apart (thanks to
    Khalil Estell)

  * Add vsscanf to tinystdio (required for libstdc++).

  * Also stick -isystem in C++ compile command to try and get
    picolibc headers to be used instead of newlib.

 -- Keith Packard <keithp@keithp.com>  Fri, 16 Jul 2021 17:57:26 -0700

picolibc (1.7.1-1) unstable; urgency=medium

  *  1. Add __cxa_atexit implementation to 'picoexit' path as required by
    C++

  * Fix lack of 'hh' support in integer-only tinystdio printf path.

  * Fix tinystdio __file flag initialization for C++ apps

 -- Keith Packard <keithp@keithp.com>  Mon, 12 Jul 2021 14:16:57 -0700

picolibc (1.7-1) unstable; urgency=medium

  * Merge libc and libm into a single library. Having them split
    doesn't offer any advantages while requiring that applications add
    '-lm' to link successfully. Having them merged allows use of libm
    calls from libc code.

  * Add hex float format to *printf, *scanf and strto{d,f,ld}. This is
    required for C99 support.

  * Unify strto{d,f,ld} and *scanf floating point parsing code. This
    ensures that the library is consistent in how floats are parsed.

  * Make strto{d,f,ld} set errno to ERANGE on overflow/underflow,
    including when the result is a subnormal number.

 -- Keith Packard <keithp@keithp.com>  Fri, 02 Jul 2021 11:11:39 -0700

picolibc (1.6.2-1) unstable; urgency=medium

  * Change `restrict` keyword in published headers to `__restrict` to
    restore compatibility with applications building with --std=c18.

  * Additional cleanups in time conversion funcs (Thanks to R. Riez)

 -- Keith Packard <keithp@keithp.com>  Thu, 17 Jun 2021 08:53:58 -0700

picolibc (1.6.1-1) unstable; urgency=medium

  * Code cleanups for time conversion funcs (Thanks to R. Diez)

  * Add '-fno-stack-protector' when supported by the C compiler
    to avoid trouble building with native Ubuntu GCC.

  * Bug fix for converting denorms with sscanf and strto{d,f,ld}.

  * Use __asm__ for inline asm code to allow building applications
    with --std=c18

  * Fix exit code for semihosting 'abort' call to make it visible
    to the hosting system.

  * Add strfromf and strfromd implementations. These are simple
    wrappers around sscanf, but strfromf handles float conversions
    without requiring a pass through 'double' or special linker hacks.

 -- Keith Packard <keithp@keithp.com>  Thu, 10 Jun 2021 12:34:19 -0700

picolibc (1.6-1) unstable; urgency=medium

  * Bugfix for snprintf(buf, 0) and vsnprintf(buf, 0) to avoid
    smashing memory

  * Support building libstdc++ on top of picolibc

  * Add 'hosted' crt0 variant that calls exit when main
    returns. This makes testing easier without burdening embedded apps
    with unused exit processing code.

  * Add 'minimal' crt0 variant that skips constructors to
    save space on systems known to not use any.

  * Fix HW floating point initialization on 32-bit ARM processors to
    perform 'dsb' and 'isb' instructions to ensure the FPU enabling
    write is complete before executing any FPU instructions.

  * Create a new '--picolibc-prefix' GCC command line parameter that
    sets the base of all picolibc file names.

  * Add bare-metal i386 and x86_64 initializatiton code (thanks to
    Mike Haertel). These initialize the processor from power up to
    running code without requiring any BIOS.

  * Merge newlib as of late April, 2021

  * Add 'timegm' function (thanks to R. Diez).

  * Fix a number of tinystdio bugs: handle fread with size==0, parse
    'NAN' and 'INF' in fscanf in a case-insensitive manner, fix
    negative precision to '*' arguments in printf, fix handling of
    'j', 'z' and 't' argument size specifiers (thanks to Sebastian
    Meyer).

  * Make the fenv API more consistent and more conformant with the
    spec. All architectures now fall back to the default code
    for soft float versions, which avoids having the various exception
    and rounding modes get defined when not supported.

 -- Keith Packard <keithp@keithp.com>  Fri, 04 Jun 2021 18:46:30 -0700

picolibc (1.5.1-3) unstable; urgency=medium

  * Change how test architecures are selected (thanks to Paul Gevers).

  * Test on aarch64

 -- Keith Packard <keithp@keithp.com>  Wed, 27 Jan 2021 10:34:41 -0800
